	
		////////////////////////////////////////////////////////////
		//////////////////////// Set-up ////////////////////////////
		////////////////////////////////////////////////////////////

 		var screenWidth = window.innerWidth;

		var margin = {left: 20, top: 20, right: 20, bottom: 20},
			width = Math.min(screenWidth, 500) - margin.left - margin.right,
			height = Math.min(screenWidth, 500) - margin.top - margin.bottom;


			//Tooltip
		var tip = d3.tip()
		  .attr('class', 'd3-tip')
		  .offset([-10, 0])
		  .html(function(d, i) {
		    return d.tooltip;
		  })
							
		var svg = d3.select("#chart").append("svg")
					.attr("width", (width + margin.left + margin.right))
					.attr("height", (height + margin.top + margin.bottom))
				   .append("g").attr("class", "wrapper")
					.attr("transform", "translate(" + (width / 2 + margin.left) + "," + (height / 2 + margin.top) + ")");

		svg.call(tip);
		
		////////////////////////////////////////////////////////////// 
		///////////////////// Data &  Scales ///////////////////////// 
		////////////////////////////////////////////////////////////// 

			//Compare both directions' count of stops and generate length of arcs
		var stopsTop = 80; //change to dynamic
		var stopsBottom = 69; //change to dynamic
		var topArcLength = 0;
		var bottomArcLength = 0;

		if (stopsTop > stopsBottom) {
			topArcLength = 180;
			bottomArcLength = (stopsBottom/stopsTop)*180;
		} else if (stopsTop < stopsBottom) {
			bottomArcLength = 180;
			topArcLength = (stopsTop/stopsBottom)*180;
		} else {
			bottomArcLength = 180;
			topArcLength = 180;
		}

		var innerRadius = (width*0.85/2) - 5;
		//padding between arcs
		var padAngle = Math.PI/180 * 1; //0.019699120601553645; 

		var bottomArcStartAngle = ( 90 * Math.PI / 180) - padAngle;
		var topArcStartAngle = ( 270 * Math.PI / 180) - padAngle;

		var stopsBottomCount = 0;
		var stopsTopCount = 0;

		var bottomStops2;
		var topStops2;

		var bottomArcData = [];
		var topArcData = [];

		var trips = [];
		
		//data for roads (names) and stops (count)
		var async1 = $.ajax({
		    url: "/en/bi/report/api:viewDetail/#PARAM=table1#",
		    success: function(response) {        



		        for (i = 0; i < response.data.header[1].length; i++) {
		        	var direction = response.data.header[1][i].value.split('</a>', 2)[1];

		        	if (direction == "Top") {
		        		break;
		        	} else { bottomArcData[i] = {roadName: response.data.header[3][i].value.split('</a>', 2)[1], stops: parseInt(response.data.body[0][i].value)};
		        			stopsBottomCount += parseInt(response.data.body[0][i].value);
		        }


		        }
		    

		        var j = 0;

		        for (i = 0; i < response.data.header[1].length; i++) {
		        	var direction = response.data.header[1][i].value.split('</a>', 2)[1];

		        	if (direction == "Bottom") {
		        		continue;
		        	} else {
		        		topArcData[j] = {roadName: response.data.header[3][i].value.split('</a>', 2)[1], stops: parseInt(response.data.body[0][i].value)};
		        		stopsTopCount += parseInt(response.data.body[0][i].value);
		        		j++;
		        	}


		        }

		   
		      

		//Draw Arcs for both directions
		//Arc starts at 3' oclock 
		drawArcs(bottomArcData, "Bottom", 90, 90 + bottomArcLength); // start angle for bottomArc is a constant
		drawArcs(topArcData, "Top", 450 - topArcLength , 450); // end angle for topArc is a constant
		    }
		});
		
		//data for stops - IDs & names
		var async2 = $.ajax({
		    url: "/en/bi/report/api:viewDetail/#PARAM=table2#",
		    success: function(response) {

		        var stops = [];

		        for (i = 0; i < response.data.header[0].length; i++) {
		        	stops[i] = {stopID: parseInt(response.data.header[0][i].value.split('</a>', 2)[1]), tooltip: response.data.header[1][i].value.split('</a>', 2)[1]};
		        }

		        //all stops are sorted by ID here
		        //split this array to 2 parts - for the bottom and top part
		        stops.sort(function (a, b) {
				  if (a.stopID > b.stopID) {
				    return 1;
				  }
				  if (a.stopID < b.stopID) {
				    return -1;
				  }
				  // a must be equal to b
				  return 0;
				});

		        bottomStops2 = stops.slice(0, stopsBottomCount);
		        topStops2 = stops.slice(stopsBottomCount, stopsBottomCount + stopsTopCount);


		    }
		});

				//data for trips
		var async3 = $.ajax({
		    url: "/en/bi/report/api:viewDetail/#PARAM=table3#",
		    success: function(response) {
		        /*console.log(response);*/

		        //passengers
		        for (i = 0; i < response.data.body[0].length; i++) {

		        	trips[i] = {	passengers: response.data.body[0][i].value,
			        				startStopID: response.data.header[1][i].value.split('</a>', 2)[1],
			        				startStopName: response.data.header[2][i].value.split('</a>', 2)[1],
			        				destinationStopID: response.data.header[3][i].value.split('</a>', 2)[1],
			        				destinationStopName: response.data.header[4][i].value.split('</a>', 2)[1],
			        				tooltip: response.data.body[0][i].value + " trips from " + response.data.header[2][i].value.split('</a>', 2)[1] + " to " + response.data.header[4][i].value.split('</a>', 2)[1]
			        			};

		        }		  
		    }
		});

		//When all async calls are finished all variables are available inside this function
		$.when(async1, async2, async3).done(function(result1, result2, result3) {


			placeCircles(topArcStartAngle, topArcLength, 3, topStops2.length, "top", topStops2);
			placeCircles(bottomArcStartAngle, bottomArcLength, 2, bottomStops2.length, "bottom", bottomStops2);
			placeLines(trips);
			drawLabel1();
			drawLabel2();
			drawLabel3();
						});

		//data - test #2
		var bottomStops = [];

		for (i = 0; i < 71; i++) {
			bottomStops[i] = {tooltip: "Bottom Stop #" + i};
		}

		var topStops = [];

		for (i = 0; i < 81; i++) {
			topStops[i] = {tooltip: "Top Stop #" + i};
		}

		//trip data for curve visualization
		/*var tripDataBottom = [];

		for (i = 0; i < 10; i++) {
			tripDataBottom[i] = {startStopID: "bottom" + i, destinationStopID: "bottom" + 2*i, tooltip: "Curve Bottom Tooltip #" + i};
		}

		var tripDataTop = [];

		for (i = 0; i < 10; i++) {
			tripDataTop[i] = {startStopID: "top" + i, destinationStopID: "top" + 2*i, tooltip: "Curve Top Tooltip #" + i};
		}
*/

		//Create a color scale
		var colorScale = d3.scaleLinear()
		   .domain([1,3.5,6])
		   .range(["#2c7bb6", "#ffffbf", "#d7191c"])
		   .interpolate(d3.interpolateHcl);

		//Create an arc function   
		var arc = d3.arc()
			.innerRadius(width*0.85/2) 
			.outerRadius(width*0.75/2 + 30);

		
		//Wrapp the code so it can be used for both arcs
		function drawArcs(data, orientation, startAngle, endAngle) {

		//Partial pie chart	
		var pie = d3.pie()
			.startAngle(Math.PI/180 * startAngle)
			.endAngle( Math.PI/180 * endAngle)
			.value(function(d) { return d.stops; })
			.sort(null)	// d3.pie automatically sorts values descending so it has to be disabled to respect order from JSON
			.padAngle(padAngle);
		 
		////////////////////////////////////////////////////////////// 
		//////////////////// Create Donut Chart ////////////////////// 
		////////////////////////////////////////////////////////////// 

		//Create the donut slices and also the invisible arcs for the text 
		svg.selectAll(".donutArcs" + orientation)
			.data(pie(data))
		  .enter().append("path")
			.attr("class", "donutArcs" + orientation)
			.attr("d", arc)
			.style("fill", function(d,i) {
				if(i === 7) return "#CCCCCC"; //Other
				else return colorScale(i+1); 
			})
			.attr('opacity', 0)
			.transition()
			    .duration(2000)
			    .style('opacity', 1)

			.each(function(d,i) {
				//Search pattern for everything between the start and the first capital L
				var firstArcSection = /(^.+?)L/; 	

				//Grab everything up to the first Line statement
				var newArc = firstArcSection.exec( d3.select(this).attr("d") )[1];
				//Replace all the comma's so that IE can handle it
				newArc = newArc.replace(/,/g , " ");
				
				//If the end angle lies beyond a quarter of a circle (90 degrees or pi/2) 
				//flip the end and start position
				if (((d.endAngle > 90 * Math.PI/180) && orientation == "Bottom") || ((d.endAngle > 450 * Math.PI/180) && orientation == "Top")) {
					var startLoc 	= /M(.*?)A/,		//Everything between the first capital M and first capital A
						middleLoc 	= /A(.*?)0 0 1/,	//Everything between the first capital A and 0 0 1
						endLoc 		= /0 0 1 (.*?)$/;	//Everything between the first 0 0 1 and the end of the string (denoted by $)
					//Flip the direction of the arc by switching the start en end point (and sweep flag)
					//of those elements that are below the horizontal line
					var newStart = endLoc.exec( newArc )[1];
					var newEnd = startLoc.exec( newArc )[1];
					var middleSec = middleLoc.exec( newArc )[1];
					
					//Build up the new arc notation, set the sweep-flag to 0
					newArc = "M" + newStart + "A" + middleSec + "0 0 0 " + newEnd;
				}//if
				
				//Create a new invisible arc that the text can flow along
				svg.append("path")
					.attr("class", "hiddenDonutArcs" + orientation)
					.attr("id", "donutArc" + i + orientation)
					.attr("d", newArc )
					.style("fill", "none");
			});
			
		//Append the label roadName on the outside
		svg.selectAll(".donutText" + orientation)
			.data(pie(data))
		   .enter().append("text")
			.attr("class", "donutText" + orientation)
			//Move the labels below the arcs for those slices with an end angle greater than 90 degrees
			.attr("dy", function(d,i) { return (orientation == "Bottom" ? 18 : -11); })
		   .append("textPath")
			.attr("startOffset","50%")
			.style("text-anchor","middle")
			.attr("xlink:href",function(d,i){return "#donutArc"+ i + orientation;})
			.text(function(d){return d.data.roadName;})
			.attr('opacity', 0)
			.transition()
			    .duration(2500)
			    .style('opacity', 1);

		}

		function placeCircles(arcStartAngle, arcLength, numberOfRoads, numberOfStops, direction, data) {	
			
			var radianDiff = ((arcLength * Math.PI/180) - ((numberOfRoads + 2) * padAngle))/(numberOfStops - 2);
				// radianDiff and padAngle*2 should be ideally equal for correct layout of circles
			
			svg.selectAll("circle" + " " + direction)
				.data(data)
			    .enter()
			    .append("circle")
			    .style("stroke", "#555")
			    .style("fill", "#555")
			    .attr('opacity', 0)
			    .attr("r", 2)
			    .attr("cx", function(d, i) { return Math.sin(arcStartAngle - i * radianDiff) * innerRadius })
			    .attr("cy", function(d, i) { return Math.cos(arcStartAngle - i * radianDiff) * innerRadius })
			    .attr("class", "hoverable")
			    .attr("id", function(d, i) {return d.stopID})
			    .on('mouseover', tip.show)
   				.on('mouseout', tip.hide)
			    .transition()
			    .delay(function(d,i) { return i * 10; })
			    .duration(4000)
			    .style('opacity', 1);
			 

		  

		}

	    var bezierLine = d3.line()
		    .x(function(d) { return d[0]; })
		    .y(function(d) { return d[1]; })
		    .curve(d3.curveCardinal.tension(0));

	
		
		//Scale for the width of curve which represents number of passengers
		var strokeWidth = d3.scaleLinear()
						    .domain([0, 300])	//input
						    .range([0.005, 4.5]);	//output

		//Scale for the height of curve which represents number of passengers
		var curveModifier = d3.scaleLinear()
						    .domain([0, 300])	//input
						    .range([1, 2]);	//output



		function placeLines(data) {

					svg.selectAll("tripLine")
					.data(data)
					.enter()
					.append('path')
				    .attr("d", function(d) {
				    	//get coordinates of the stops which will be connected by a curve
				    	var element1x = parseFloat(document.getElementById(d.startStopID).getAttribute('cx'));
						var element1y = parseFloat(document.getElementById(d.startStopID).getAttribute('cy'));
						var element2x = parseFloat(document.getElementById(d.destinationStopID).getAttribute('cx'));
						var element2y = parseFloat(document.getElementById(d.destinationStopID).getAttribute('cy'));

							// get point in the middle of the line
						var midPointX = (element1x + element2x)/2;
						var midPointY = (element1y + element2y)/2;

				    		return bezierLine([[element1x * 0.985, element1y * 0.985], [midPointX/curveModifier(d.passengers), midPointY/curveModifier(d.passengers)], [element2x * 0.985, element2y * 0.985]])
				    		}) // point in the middle represents count of passengers (scaled)

				    .attr("stroke", "grey")
				    .attr("stroke-width", function(d) { return strokeWidth(d.passengers)})	// scale from 0.005 to 4.5
				    .attr("class", "tripLine")
				    .attr("fill", "none")
				    .attr('opacity', 0)
				    .on('mouseover', tip.show)
   					.on('mouseout', tip.hide)
				    .transition()
			        .duration(2000)
			        .style('opacity', 1) //fixes the blink on the beginning
			        .attrTween("stroke-dasharray", function() {
			            var len = this.getTotalLength();
			            return function(t) { return (d3.interpolateString("0," + len, len + ",0"))(t) };
			        });
			
		}

	function drawLabel1() {
		svg.append("text")
		    .attr("x", 0)
		    .attr("y", -20)
		    .attr("dy", ".35em")
		    .attr("text-anchor", "middle")
		    .attr("class", "serviceName")
		    .attr('opacity', 0)
		    .attr("stroke", "none")
		    .attr("fill", "#444")
		    .attr("font-weight", "700")
		    .attr("pointer-events", "none")
		    .text("Bus Route #9")
		    .transition()
			    .duration(4000)
			    .style('opacity', 1);
	}

	function drawLabel2() {
		svg.append("text")
		    .attr("x", 0)
		    .attr("y", 0)
		    .attr("dy", ".35em")
		    .attr("text-anchor", "middle")
		    .attr("class", "serviceName")
		    .attr('opacity', 0)
		    .attr("stroke", "none")
		    .attr("fill", "#96D096")
		    .attr("font-weight", "200")
		    .attr("pointer-events", "none")
		    .text("Weekday")
		    .transition()
			    .duration(4000)
			    .style('opacity', 1);
	}

	function drawLabel3() {
		svg.append("text")
		    .attr("x", 0)
		    .attr("y", 20)
		    .attr("dy", ".35em")
		    .attr("text-anchor", "middle")
		    .attr("class", "serviceName")
		    .attr('opacity', 0)
		    .attr("stroke", "none")
		    .attr("fill", "#444")
		    .attr("font-weight", "200")
		    .attr("pointer-events", "none")
		    .text("25,442 pax")
		    .transition()
			    .duration(4000)
			    .style('opacity', 1);
	}
